Attribute VB_Name = "modTrustedLocation"
Option Compare Database
Option Explicit

' Constants (taken from WinReg.h)
Const HKEY_CLASSES_ROOT = &H80000000
Const HKEY_CURRENT_USER = &H80000001
Const HKEY_LOCAL_MACHINE = &H80000002
Const HKEY_USERS = &H80000003

Const REG_SZ = 1
Const REG_EXPAND_SZ = 2
Const REG_BINARY = 3
Const REG_DWORD = 4
Const REG_MULTI_SZ = 7

Function IsLocationTrusted() As Boolean

On Error GoTo Err_Handler

        IsLocationTrusted = False
        
        Dim strComputer As String, hDefKey As Long, strKeyPath As String, strSubKeyPath As String, strAccessVersion As String
        Dim strValueName As String, strValue As Variant, I As Integer, oReg As Object
        Dim strSubkey As Variant, arrSubKeys As Variant, arrValueNames As Variant, arrTypes As Variant, uValue As Variant
      '  Dim strBytes As String, uByte As Variant, arrBytes As Variant, arrValues As Variant
        
        ' Get computer name, registry tree and key path
        strAccessVersion = SysCmd(acSysCmdAccessVer)
        '
        strComputer = "." ' Use . for current machine
        hDefKey = HKEY_CURRENT_USER
        strKeyPath = "SOFTWARE\Microsoft\Office\" & strAccessVersion & "\Access\Security\Trusted Locations"
        
        ' Connect to registry provider on target machine with current user
        Set oReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\default:StdRegProv")
        
        ' Enum the subkeys of the key path we've chosen
        oReg.EnumKey hDefKey, strKeyPath, arrSubKeys
        
        For Each strSubkey In arrSubKeys
        
          ' Show the subkey
        '  Debug.Print vbCrLf & strSubkey
        
          ' Show its value names and types
          strSubKeyPath = strKeyPath & "\" & strSubkey
          oReg.EnumValues hDefKey, strSubKeyPath, arrValueNames, arrTypes
        
          For I = LBound(arrValueNames) To UBound(arrValueNames)
            
            strValueName = arrValueNames(I)
            Select Case arrTypes(I)
            
              ' Show a REG_DWORD value
              Case REG_DWORD
                oReg.GetDWORDValue hDefKey, strSubKeyPath, strValueName, uValue
               ' Debug.Print strSubKeyPath ', strValueName, uValue
               ' If strValueName = "AllowSubfolders" Then
                 '   Debug.Print "  " & strValueName & " (REG_DWORD) = " & CStr(uValue)
              '  End If
              
              ' Show a REG_SZ value
              Case REG_SZ
                oReg.GetStringValue hDefKey, strSubKeyPath, strValueName, strValue
              '  Debug.Print "  " & strValue & " (REG_SZ) = " & strValue
                If strValueName = "Path" Then
                    If uValue = 1 Then 'AllowSubfolders=True
                        If InStr(CurrentProject.Path, strValue) <> 0 Then 'match found
                            'Debug.Print "Path = " & strValue & vbTab & "   AllowSubfolders = " & uValue
                            IsLocationTrusted = True
                            GoTo Trusted
                        End If
                    Else 'uValue=0; AllowSubfolders=False
                        If CurrentProject.Path = strValue Then 'match found
                           'Debug.Print "Path = " & strValue & vbTab & "   AllowSubfolders = " & uValue
                           IsLocationTrusted = True
                           GoTo Trusted
                        End If
                    End If
                End If
                
            End Select
          Next I
        
        Next strSubkey
        
Trusted:
        If IsLocationTrusted Then
           Debug.Print ""
           Debug.Print "TrustedLocation = " & strSubkey
           Debug.Print "Path = " & strValue
           Debug.Print "AllowSubfolders = " & uValue
           Debug.Print "The current project folder is trusted for Access " & strAccessVersion
        End If
        
        Debug.Print "IsLocationTrusted = " & IsLocationTrusted
            
Exit_Handler:
    Exit Function
    
Err_Handler:
    MsgBox "Error " & Err & " in IsLocationTrusted procedure: " & vbCrLf & Err.description
    GoTo Exit_Handler

End Function


